

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GstVideo.Objects
    (     module GI.GstVideo.Objects.ColorBalanceChannel,
    module GI.GstVideo.Objects.VideoAggregator,
    module GI.GstVideo.Objects.VideoAggregatorConvertPad,
    module GI.GstVideo.Objects.VideoAggregatorPad,
    module GI.GstVideo.Objects.VideoBufferPool,
    module GI.GstVideo.Objects.VideoDecoder ,
    module GI.GstVideo.Objects.VideoEncoder ,
    module GI.GstVideo.Objects.VideoFilter  ,
    module GI.GstVideo.Objects.VideoMultiviewFlagsSet,
    module GI.GstVideo.Objects.VideoSink    ,


    ) where

import GI.GstVideo.Objects.ColorBalanceChannel
import GI.GstVideo.Objects.VideoAggregator
import GI.GstVideo.Objects.VideoAggregatorConvertPad
import GI.GstVideo.Objects.VideoAggregatorPad
import GI.GstVideo.Objects.VideoBufferPool
import GI.GstVideo.Objects.VideoDecoder
import GI.GstVideo.Objects.VideoEncoder
import GI.GstVideo.Objects.VideoFilter
import GI.GstVideo.Objects.VideoMultiviewFlagsSet
import GI.GstVideo.Objects.VideoSink

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL



