#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))
module GI.GstVideo.Interfaces.VideoOrientation where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

newtype VideoOrientation = VideoOrientation (ManagedPtr VideoOrientation)
class ManagedPtrNewtype a => IsVideoOrientation a
instance WrappedPtr VideoOrientation where
#if ENABLE_OVERLOADING
data VideoOrientationGetHcenterMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationGetHflipMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationGetVcenterMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationGetVflipMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationSetHcenterMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationSetHflipMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationSetVcenterMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoOrientationSetVflipMethodInfo
#endif
