#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))
module GI.GstVideo.Objects.VideoDecoder where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

newtype VideoDecoder = VideoDecoder (ManagedPtr VideoDecoder)
instance GObject VideoDecoder where
class (GObject o, O.IsDescendantOf VideoDecoder o) => IsVideoDecoder o
instance (GObject o, O.IsDescendantOf VideoDecoder o) => IsVideoDecoder o
instance O.HasParentTypes VideoDecoder
#if ENABLE_OVERLOADING
data VideoDecoderAddToFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderAllocateOutputBufferMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderAllocateOutputFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderAllocateOutputFrameWithParamsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderDropFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderFinishFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetAllocatorMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetBufferPoolMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetEstimateRateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetFramesMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetLatencyMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetMaxDecodeTimeMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetMaxErrorsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetNeedsFormatMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetOldestFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetOutputStateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetPacketizedMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetPendingFrameSizeMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderGetQosProportionMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderHaveFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderMergeTagsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderNegotiateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderProxyGetcapsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderReleaseFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetEstimateRateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetInterlacedOutputStateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetLatencyMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetMaxErrorsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetNeedsFormatMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetOutputStateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetPacketizedMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoDecoderSetUseDefaultPadAcceptcapsMethodInfo
#endif
