#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))
module GI.GstVideo.Objects.VideoEncoder where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

newtype VideoEncoder = VideoEncoder (ManagedPtr VideoEncoder)
instance GObject VideoEncoder where
class (GObject o, O.IsDescendantOf VideoEncoder o) => IsVideoEncoder o
instance (GObject o, O.IsDescendantOf VideoEncoder o) => IsVideoEncoder o
instance O.HasParentTypes VideoEncoder
#if ENABLE_OVERLOADING
data VideoEncoderQosPropertyInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderAllocateOutputBufferMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderAllocateOutputFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderFinishFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetAllocatorMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetFramesMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetLatencyMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetMaxEncodeTimeMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetOldestFrameMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderGetOutputStateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderIsQosEnabledMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderMergeTagsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderNegotiateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderProxyGetcapsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderSetHeadersMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderSetLatencyMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderSetMinPtsMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderSetOutputStateMethodInfo
#endif
#if ENABLE_OVERLOADING
data VideoEncoderSetQosEnabledMethodInfo
#endif
