

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GstVideo.Structs
    (     module GI.GstVideo.Structs.VideoAffineTransformationMeta,
    module GI.GstVideo.Structs.VideoAlignment,
    module GI.GstVideo.Structs.VideoAncillary,
    module GI.GstVideo.Structs.VideoCaptionMeta,
    module GI.GstVideo.Structs.VideoChromaResample,
    module GI.GstVideo.Structs.VideoCodecFrame,
    module GI.GstVideo.Structs.VideoCodecState,
    module GI.GstVideo.Structs.VideoColorPrimariesInfo,
    module GI.GstVideo.Structs.VideoColorimetry,
    module GI.GstVideo.Structs.VideoConverter,
    module GI.GstVideo.Structs.VideoCropMeta,
    module GI.GstVideo.Structs.VideoDither  ,
    module GI.GstVideo.Structs.VideoFormatInfo,
    module GI.GstVideo.Structs.VideoFrame   ,
    module GI.GstVideo.Structs.VideoGLTextureUploadMeta,
    module GI.GstVideo.Structs.VideoInfo    ,
    module GI.GstVideo.Structs.VideoMeta    ,
    module GI.GstVideo.Structs.VideoMetaTransform,
    module GI.GstVideo.Structs.VideoOverlayComposition,
    module GI.GstVideo.Structs.VideoOverlayCompositionMeta,
    module GI.GstVideo.Structs.VideoOverlayRectangle,
    module GI.GstVideo.Structs.VideoRectangle,
    module GI.GstVideo.Structs.VideoRegionOfInterestMeta,
    module GI.GstVideo.Structs.VideoResampler,
    module GI.GstVideo.Structs.VideoScaler  ,
    module GI.GstVideo.Structs.VideoTimeCode,
    module GI.GstVideo.Structs.VideoTimeCodeConfig,
    module GI.GstVideo.Structs.VideoTimeCodeInterval,
    module GI.GstVideo.Structs.VideoTimeCodeMeta,
    module GI.GstVideo.Structs.VideoVBIEncoder,
    module GI.GstVideo.Structs.VideoVBIParser,


    ) where

import GI.GstVideo.Structs.VideoAffineTransformationMeta
import GI.GstVideo.Structs.VideoAlignment
import GI.GstVideo.Structs.VideoAncillary
import GI.GstVideo.Structs.VideoCaptionMeta
import GI.GstVideo.Structs.VideoChromaResample
import GI.GstVideo.Structs.VideoCodecFrame
import GI.GstVideo.Structs.VideoCodecState
import GI.GstVideo.Structs.VideoColorPrimariesInfo
import GI.GstVideo.Structs.VideoColorimetry
import GI.GstVideo.Structs.VideoConverter
import GI.GstVideo.Structs.VideoCropMeta
import GI.GstVideo.Structs.VideoDither
import GI.GstVideo.Structs.VideoFormatInfo
import GI.GstVideo.Structs.VideoFrame
import GI.GstVideo.Structs.VideoGLTextureUploadMeta
import GI.GstVideo.Structs.VideoInfo
import GI.GstVideo.Structs.VideoMeta
import GI.GstVideo.Structs.VideoMetaTransform
import GI.GstVideo.Structs.VideoOverlayComposition
import GI.GstVideo.Structs.VideoOverlayCompositionMeta
import GI.GstVideo.Structs.VideoOverlayRectangle
import GI.GstVideo.Structs.VideoRectangle
import GI.GstVideo.Structs.VideoRegionOfInterestMeta
import GI.GstVideo.Structs.VideoResampler
import GI.GstVideo.Structs.VideoScaler
import GI.GstVideo.Structs.VideoTimeCode
import GI.GstVideo.Structs.VideoTimeCodeConfig
import GI.GstVideo.Structs.VideoTimeCodeInterval
import GI.GstVideo.Structs.VideoTimeCodeMeta
import GI.GstVideo.Structs.VideoVBIEncoder
import GI.GstVideo.Structs.VideoVBIParser

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL



